import java.util.Scanner;

class StringComp {
	
	public static void main(String[] args) {
		String s = "abx"; // s is in the string pool already
		System.out.println("String s = \"abx\";");
		String s0 = new String(new char[] {'a', 'b', 'x'});
		System.out.println("String s0 = new String(new char[] {'a', 'b', 'x'});");
		// String s0 = s.toString(); // compiler is smart, sourse is already interned
		System.out.println("String s0 = s.toString();");
		String s1 = new String("abx"); 
		System.out.println("String s1 = new String(\"abx\");");
		//every time the content is set after memory allocation,
		//thus initialised string object will be new
		System.out.print("type in abx: ");
		String s2 = (new Scanner(System.in)).next(); // type in "abx"
		System.out.println("String s2 = new Scanner(System.in).next();//user types abx");
		String s3 = s2.toString(); // alternative to s0, when source isn't interned
		System.out.println("String s3 = s2.toString();");
		System.out.println("See the results of object value and ref comparisons:");
		System.out.printf("%-12s %-12s %-12s %-12s%n",
			"s and s0","s and s1","s and s2","s and s3");
		System.out.printf("%-12b %-12b %-12b %-12b (object equality)%n", 
			s.equals(s0), s.equals(s1), s.equals(s2), s.equals(s3));
		System.out.printf("%-12b %-12b %-12b %-12b (reference equality)%n",
			s == s0, s == s1, s == s2, s == s3);
		
		System.out.println("=============================================");
		System.out.println("After internment on all (save s) strings");
		// String[] strings = new String[] {s0, s1, s2, s3}; // that would wrong
		// for (String str: strings)
		// 	str = str.intern();
		s0 = s0.intern();
		s1 = s1.intern();
		s2 = s2.intern();
		s3 = s3.intern();
		System.out.println("Same tests again:");
		System.out.println();
		System.out.printf("%-12s %-12s %-12s %-12s%n",
			"s and s0","s and s1","s and s2","s and s3");
		System.out.printf("%-12b %-12b %-12b %-12b (object equality)%n", 
			s.equals(s0), s.equals(s1), s.equals(s2), s.equals(s3));
		System.out.printf("%-12b %-12b %-12b %-12b (reference equality)%n", 
			s == s0, s == s1, s == s2, s == s3);
	}
}